Actually compile Wine even if not installing as root.
[wine] / tools / wineinstall
1 #!/bin/bash
2 # WINE Installation script
3 # Can do almost everything from compiling to configuring...
4 #
5 # Copyright 1999 Ove Kåven
6 #
7 # This library is free software; you can redistribute it and/or
8 # modify it under the terms of the GNU Lesser General Public
9 # License as published by the Free Software Foundation; either
10 # version 2.1 of the License, or (at your option) any later version.
11 #
12 # This library is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
15 # Lesser General Public License for more details.
16 #
17 # You should have received a copy of the GNU Lesser General Public
18 # License along with this library; if not, write to the Free Software
19 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
20 #
21 # History:
22 # Mar 31 1999 - Ove Kåven
23 #  First version
24 # Dec 9 1999 - Ove Kåven
25 #  require Xpm
26 # Feb 25 2000 - Ove Kåven
27 #  auto-add /usr/local/lib to /etc/ld.so.conf
28 # Mar 2 2000 - Ove Kåven
29 #  source rather than grep config.cache
30 #  use sourced config.cache to start ldconfig
31 #  reconfigure if config.cache doesn't exist
32 # Mar 30 2000 - Ove Kåven
33 #  autoconfigure no-windows installs
34 #  do not install registry on real-windows installs
35 #  some support for binary package installs
36 #  set and tell user about LD_LIBRARY_PATH if necessary
37 #  set EXTRA_LD_LIBRARY_PATH in wine.conf
38 # Apr 9 2000 - Ove Kåven
39 #  make root's registry global (system-default)
40 # May 9 2000 - Ove Kåven
41 #  use ttydrv when running regapi, so we don't have to run from X
42 #  change debugger path in registry
43 # Oct 29 2000 - Ove Kåven
44 #  added --enable-opengl to default confargs
45 #  added conf_question, conf_yesno_answer, and conf_string_answer functions
46 #  added DEFCAT variable
47 # (later that day...)
48 #  added conf_reset_question function
49 #  added file existence checks to the registry copying
50 #  fixed problem with no-windows directory creation
51 #  some text reformatting from Eric Maryniak
52 # Jan 5 2000 - Chris Morgan
53 #  use default config file in /documentation/samples/config
54 #  replace .winerc with ~/.wine/config in printed text
55 #  added user question to convert .winerc file(if exists) or use the default
56 #    config file
57 #  add conf_question to allow root to install a local config file and
58 #    registry
59 # Jan 12 2000 - Chris Morgan
60 #  distinguish between creating local and global config files
61 #  display a message about the status of global config files
62 #  misc cleanups and reordering of questions
63 #  added check to see if wine is installed when we are running as a normal
64 #    user and print a message if wine cannot be found
65 # Feb 16 2002 - Adam D. Moss
66 #  Use config.status instead of config.cache to check whether we're
67 #    configured/compiled and to recreate the configuration
68 # Feb 20 2002 - Adam D. Moss
69 #  Partially revert previous changes, force configure to write an
70 #    old-style config.cache
71 # Mar 27 2002 - Chris Morgan
72 #  prevent the user from running wineinstall as root
73 #  add script commands so we su root for 'make install' and other commands
74 #    that require root access
75 #  add text to tell the user we need to run stuff as root so they don't
76 #    think we are trying to pull something funny
77 # Apr 14 2002 - Dustin Navea
78 #  Fix sed command when finding real-windows registry so it actually
79 #   accesses a file (~/.wine/config) instead of null ($CONF?!)
80 #  Added search for clean-install (not upgrade) Win2k registry
81 #  (next day, after some sleep)
82 #  Fix sed string when finding real-windows registry to actually find
83 #   windows partition name in [Drive C] section
84 #  it should now almost always find the windows partition and real-windows
85 #  registry (if not, let me know)
86 # Aug 29 2002 - Rok Mandeljc <rok.mandeljc@gimb.org>
87 #  -added two symlinks; windows/winhelp.exe and windows/winhlp32.exe because it seems
88 #   that some apps look for winhlp32.exe/winhelp to display help
89 #
90
91 #--- defaults (change these if you are a packager)
92 CONFARGS="--enable-opengl"    # configure args, e.g. --prefix=/usr --sysconfdir=/etc
93 prefix=/usr/local             # installation prefix
94 sysconfdir=$prefix/etc        # where wine.conf and the global registry are supposed to be
95 bindir=$prefix/bin            # where winelib apps will be (or are) installed
96 libdir=$prefix/lib            # where libwine.so will be (or is) installed
97 exdir=documentation/samples   # where the sample system.ini resides
98 GCONF=$sysconfdir/wine.conf   # default path of the wine.conf global config file
99 LCONF=~/.wine/config          # default path of the local config file
100 BINDIST=no                    # whether called from a binary package config script
101 DOGLOBALCONF=auto             # whether to autogenerate wine.conf
102 DOLOCALCONF=auto              # whether to autogenerate localconf
103 DOWCHK=auto                   # whether to autoconfigure existing-windows installation
104 DOWINE=auto                   # whether to autoconfigure no-windows installation
105 DOREG=auto                    # whether to install default registry
106 DOAPP=auto                    # whether to install applications, distributed with Wine
107 SYSREG=yes                    # whether to make root's registry global (system-default)
108 CONVCONF=no                   # whether we are converting an existing .winerc or not
109
110 # "make install" still installs the dlls into $libdir, but this may change in the future
111 # (DLLPATH should point to them if/when they are not in standard ld.so paths)
112 DLLPATH=$libdir/wine          # default path of the dll .so files (except libwine.so)
113
114 # having the Wine debugger launched automatically will be a plus for us
115 DEBUGGER=$bindir/winedbg      # the (installed) path of winedbg
116 HDEBUGGER=debugger/winedbg    # the (non-installed) path of winedbg
117
118 # this is only for existing-windows installs
119 WINECONF=tools/wineconf       # path to the wineconf perl script
120
121 # this is only for no-windows installs
122 WINEINI=$exdir/config         # path to the default wine config file (also used by wineconf)
123 WININI=/dev/null              # path to the default win.ini
124 SYSTEMINI=$exdir/system.ini   # path to the default system.ini
125 REGEDIT=$bindir/regedit       # path to the regedit winelib application
126 DEFREG=winedefault.reg        # path of the registry file to be fed to regedit
127 # CROOT=/var/wine             # path of the fake Drive C (asks user if not set)
128 DEFCAT=cat                    # program to cat $DEFREG with (some packages need zcat)
129 #--- end of defaults
130
131 # temporary files used by the installer
132 TMPCONF=/tmp/wineinstall.conf
133 TMPREG=/tmp/wineinstall.reg
134
135 # functions
136
137 function std_sleep {
138   sleep 1
139 }
140
141 function conf_question {
142   # parameters: $1 = importance, $2 = question-id, $3+ = message lines
143   # the first two parameters can be used by e.g. debconf in debian packages
144   # but here we just print the message
145   shift 2
146   echo
147   local LINE="$1"
148   while shift
149   do {
150     echo "$LINE"
151     LINE="$1"
152   }
153   done
154 }
155
156 function conf_reset_question {
157   # parameters: $1 = question-id
158   # this is used to flush any cached answers and "already-displayed" flags
159   shift # dummy command
160 }
161
162 function conf_yesno_answer {
163   unset ANSWER
164   while [ "$ANSWER" != 'yes' ] && [ "$ANSWER" != 'no' ]
165   do {
166     echo -n "$1"
167     read ANSWER
168   }
169   done
170 }
171
172 function conf_string_answer {
173   echo -n "$1"
174   read ANSWER
175 }
176
177 function create_windows_directories {
178   for tdir in "$CROOT/windows" "$CROOT/windows/system" "$CROOT/windows/system32" \
179               "$CROOT/windows/Start Menu" "$CROOT/windows/Start Menu/Programs" \
180               "$CROOT/Program Files" "$CROOT/Program Files/Common Files" \
181               "$CROOT/windows/Profiles" "$CROOT/windows/Profiles/Administrator" \
182               "$CROOT/windows/Fonts" "$CROOT/windows/Start Menu/Programs/Startup"
183   do [ -d "$tdir" ] || mkdir "$tdir"
184   done
185   [ -f "$CROOT/windows/win.ini" ]    || cp "$WININI"    "$CROOT/windows/win.ini"
186   [ -f "$CROOT/windows/system.ini" ] || cp "$SYSTEMINI" "$CROOT/windows/system.ini"
187 }
188
189 #creates symbolic link in windows directory to installed winelib application
190 #parameters:
191 # - name of the installed winelib application
192 # - full path to application in the winelib directory
193 function link_app {
194   ln -sf $libdir/wine/$1.exe.so $2
195 }
196
197 #puts windows applications replacements to windows directories,
198 #configures them
199 function configure_wine_applications {
200   link_app notepad      "$CROOT/windows/notepad.exe"
201   link_app regedit      "$CROOT/windows/regedit.exe"
202   link_app wcmd         "$CROOT/windows/system32/cmd.exe"
203   link_app control      "$CROOT/windows/system32/control.exe"
204   link_app winhelp      "$CROOT/windows/system32/help.exe"
205   link_app notepad      "$CROOT/windows/system32/notepad.exe"
206   link_app progman      "$CROOT/windows/system32/progman.exe"
207   link_app regsvr32     "$CROOT/windows/system32/regsvr32.exe"
208   link_app winemine     "$CROOT/windows/system32/winmine.exe"
209   link_app winver       "$CROOT/windows/system32/winver.exe"
210   link_app uninstaller  "$CROOT/windows/uninstall.exe"
211   link_app winhelp      "$CROOT/windows/winhelp.exe"
212   link_app winhelp      "$CROOT/windows/winhlp32.exe"
213 }
214
215 # startup...
216
217 echo "WINE Installer v0.73"
218 echo
219
220 if [ "$BINDIST" = 'no' ]
221 then {
222
223   if ! [ -f configure ]
224   then {
225     if [ -f ../configure ]
226     then {
227       pushd ..
228     }
229     else {
230       echo "You're running this from the wrong directory."
231       echo "Change to the Wine source's main directory and try again."
232       exit 1
233     }
234     fi
235   }
236   fi
237
238   if [ `whoami` == 'root' ]
239   then {
240     echo "You are running wineinstall as root, this is not advisable. Please rerun as a user."
241     echo "Aborting."
242     exit 1
243   }
244   fi
245
246   # check whether RPM installed, and if it is, remove any old wine rpm.
247   hash rpm &>/dev/null
248   RET=$?
249   if [ $RET -eq 0 ]; then
250     if [ -n "`rpm -qi wine 2>/dev/null|grep "^Name"`" ]; then
251       echo "Warning: Old Wine RPM install detected. Do you want to remove it first?"
252       conf_yesno_answer "(yes/no) "
253       if [ "$ANSWER" = 'yes' ]; then
254         echo "We need to remove the rpm as root, please enter your root password"
255         echo
256         echo Starting wine rpm removal...
257         su -c "rpm -e wine; RET=$?"
258         if [ $RET -eq 0 ]; then
259           echo Done.
260         else
261           echo "FAILED. Probably you aren't installing as root."
262           echo "Expect problems (library conflicts with existing install etc.)."
263         fi
264       else
265         echo "Sorry, I won't install Wine when an rpm version is still installed."
266         echo "(Wine support suffered from way too many conflicts between RPM"
267         echo "and source installs)"
268         echo "Have a nice day !"
269         exit 1
270       fi
271     fi
272   fi
273
274   # check whether wine binary still available
275   if [ -n "`which wine 2>/dev/null|grep '/wine'`" ]; then
276     echo "Warning !! wine binary (still) found, which may indicate"
277     echo "a (conflicting) previous installation."
278     echo "You might want to abort and uninstall Wine first."
279     std_sleep
280   fi
281
282   # run the configure script, if necessary
283
284   if [ -f config.cache ] && [ -f Makefile ] && [ Makefile -nt configure ]
285   then {
286     echo
287     echo "I see that WINE has already been configured, so I'll skip that."
288     std_sleep
289     # load configure results
290     . ./config.cache
291   }
292   else {
293     echo "Running configure..."
294     echo
295     if ! ./configure -C $CONFARGS
296     then {
297       echo
298       echo "Configure failed, aborting install."
299       rm -f config.cache
300       exit 1
301     }
302     fi
303     # load configure results
304     . ./config.cache
305     # make sure X was found
306     eval "$ac_cv_have_x"
307     if [ "$have_x" != "yes" ]
308     then {
309       echo "Install the X development headers and try again."
310       rm -f config.cache
311       exit 1
312     }
313     fi
314   }
315   fi
316
317   # now do the compilation and install, we need to always do this because we
318   # don't want the 'make install' command we might run to run 'make' as root
319   if [ `whoami` != 'root' ]
320   then {
321     # ask the user if they want to build and install wine
322     echo
323     echo "We need to install wine as root user, do you want us to build wine,"
324     echo "'su root' and install Wine?  Enter 'no' to continue without installing"
325     conf_yesno_answer "(yes/no) "
326     ROOTINSTALL="$ANSWER"
327
328     if [ "$ROOTINSTALL" = "yes" ]
329     then {
330       # start out with the basic command
331       sucommand="make install"
332
333       # if the user doesn't have $libdir in their ld.so.conf add this
334       # to our sucommand string
335       if [ -f /etc/ld.so.conf ]
336       then
337         if ! grep -qs "$libdir" /etc/ld.so.conf
338         then {
339           echo
340           echo "$libdir doesn't exist in your /etc/ld.so.conf, it will be added"
341           echo "when we perform the install..."
342           sucommand="$sucommand;echo $libdir>>/etc/ld.so.conf"
343         }
344         fi
345         # run ldconfig always just in case some updated files dont get linked
346         sucommand="$sucommand;$ac_cv_path_LDCONFIG"
347       fi
348     }
349     fi # [ "$ROOTINSTALL" = "yes" ]
350
351     echo
352
353     echo "Compiling WINE. Grab a lunch or two, rent a video, or whatever,"
354     echo "in the meantime..."
355     echo
356     std_sleep
357
358     # try to just make wine, if this fails 'make depend' and try to remake
359     if ! { make; }
360     then {
361       if ! { make depend && make; }
362       then {
363         echo
364         echo "Compilation failed, aborting install."
365         exit 1
366       }
367       fi
368     }
369     fi
370
371     if [ "$ROOTINSTALL" = "yes" ]
372     then {
373       echo
374
375       echo "Performing 'make install' as root to install binaries, enter root password"
376
377       std_sleep
378
379       if ! su root -c "$sucommand"
380       then {
381         echo
382         echo "Either you entered an incorrect password or we failed to run"
383         echo "'$sucommand' correctly."
384         echo "If you didn't enter an incorrect password then please report this"
385         echo "error and any steps to possibly reproduce it to"
386         echo "http://bugs.winehq.com/"
387         echo
388         echo "Installation failed, aborting."
389         exit 1
390       }
391       fi
392
393       echo
394
395       # see if wine is installed on the users system, if not prompt them
396       # and then exit
397       if [ ! `which wine` ]
398       then
399         echo "Could not find wine on your system.  Run wineinstall as root to install wine"
400         echo "before re-running wineinstall as a user."
401         echo
402         echo "Exiting wineinstall"
403         exit 1;
404       fi
405     }
406     else {
407       # user didn't want to install wine so tell them about running from the
408       # current directory and set some stuff up for them
409
410       # setup to run from current directory
411       DLLPATH="$PWD/dlls"
412       if [ -z "$LD_LIBRARY_PATH" ]
413       then LD_LIBRARY_PATH="$PWD:$DLLPATH"
414       else LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$PWD:$DLLPATH"
415       fi
416       export LD_LIBRARY_PATH
417       DEBUGGER="$PWD/$HDEBUGGER"
418       echo
419       echo "NOTE! To run Wine without installing, you must set the environment variable"
420       echo "LD_LIBRARY_PATH to $PWD:$DLLPATH"
421       echo "in your logon scripts."
422       echo
423     }
424     fi # [ "$ROOTINSTALL" = "yes" ]
425   }
426   fi # [ `whoami` != 'root' ]
427
428 }
429 fi # BINDIST
430
431 # now check whether we should generate wine.conf
432 if [ -z "$DOGLOBALCONF" ]
433 then
434   DOGLOBALCONF=auto
435 fi
436
437 if [ "$DOGLOBALCONF" = 'auto' ]
438 then {
439   # see if we already have a system wine.conf
440   if [ ! -f $GCONF ] && [ `whoami` = 'root' ]
441   then
442     DOGLOBALCONF=no
443     echo "Creation of a global config file is not supported in wineinstall at this"
444     echo "time.  When the configuration architecture is cleaned up this functionality"
445     echo "will be restored to wineinstall."
446     echo
447   fi
448 }
449 fi
450
451 if [ "$DOLOCALCONF" = 'auto' ]
452 then {
453   # see if the user is root, if so, explicitly ask them if they want a
454   # local config file
455   if [ `whoami` = 'root' ]
456   then
457     echo "You are running as root.  Do you want a local config file,"
458     echo "file, ~/.wine/config, created?"
459     conf_yesno_answer "(yes/no) "
460     DOLOCALCONF="$ANSWER"
461   else
462     # if the user has an existing config file ask them if they want us to
463     # overwrite it, otherwise just ask them if they want to create one
464     if [ -f "$LCONF" ]
465     then
466       echo "Found existing $LCONF, do you want to overwrite this"
467       echo "existing Wine configuration file?"
468       conf_yesno_answer "(yes/no) "
469       DOLOCALCONF="$ANSWER"
470       echo
471       if [ "$ANSWER" = "yes" ]
472       then
473       {
474         echo "Would you like to make a backup of this old config file?"
475         conf_yesno_answer "(yes/no) "
476         echo
477         if [ "$ANSWER" = "yes" ]
478         then
479         {
480           echo "Renaming $LCONF to $LCONF.old"
481           mv -f "$LCONF" "$LCONF.old"
482           echo
483         }
484         fi
485       }
486       fi
487     else
488     {
489       echo "Create local config file ~/.wine/config?"
490       conf_yesno_answer "(yes/no) "
491       DOLOCALCONF="$ANSWER"
492       echo
493       if [ "$ANSWER" = 'no' ]
494       then
495         conf_question high need_root \
496           "Aborting install. Try again as root to generate a system wine.conf."
497         exit 1
498       fi
499     }
500     fi
501   fi
502 }
503 fi
504
505 # generate $TMPCONF from existing windows install, if any
506 if [ "$DOLOCALCONF" = 'yes' ]
507 then {
508   if [ "$DOWCHK" = 'yes' ] || [ "$DOWCHK" = 'auto' ]
509   then {
510     echo -n "Searching for an existing Windows installation..."
511     if ! $WINECONF -inifile "$WINEINI" > $TMPCONF 2>/dev/null
512     then {
513       rm -f $TMPCONF $TMPREG > /dev/null
514
515       echo " not found. (no matching /etc/fstab mount entry found)"
516       conf_question low do_without_windows \
517        "Windows was not found on your system, so I assume you want" \
518        "a Wine-only installation. Am I correct?"
519       conf_yesno_answer "(yes/no) "
520       if [ "$ANSWER" = 'no' ]
521       then {
522         conf_question high windows_not_found \
523          "Aborting install. Make sure your Windows partition is mounted and try again," \
524          "or create $LCONF manually by copying from $WINEINI and adapting the drive paths."
525         exit 1
526       }
527       fi
528       DOWINE=yes
529     }
530     else {
531       echo " found."
532
533       conf_reset_question windows_found
534       conf_question low windows_found \
535        "Created $LCONF using your existing Windows installation." \
536        "You probably want to review the file, though."
537       DOWINE=no
538     }
539     fi
540   }
541   elif [ "$DOWINE" = 'auto' ]
542   then DOWINE=yes
543   fi
544 }
545 elif [ "$DOWINE" = 'auto' ]
546 then
547   DOWINE=no
548 fi
549
550 # setup a no-windows installation, if necessary
551 if [ "$DOWINE" = 'yes' ]
552 then {
553   # set an appropriate DCROOT
554   if [ `whoami` != 'root' ]
555   then DCROOT=~/c
556   else DCROOT=/c
557   fi
558
559   if [ -f ~/.winerc ]
560   then {
561     conf_question medium convert_config \
562      "I found the old version Wine config file, .winerc, in your " \
563      "home directory.  I can convert this to the new format or use the" \
564      "new default Wine config file. Convert?"
565     conf_yesno_answer "(yes/no) "
566     if [ "$ANSWER" = 'yes' ]
567     then {
568       WINEINI=~/.winerc
569       CONVCONF=yes
570     }
571     fi
572   }
573   else {
574
575     conf_question low drivec_path \
576      "Configuring Wine without Windows." \
577      "Some fake Windows directories must be created, to hold any .ini files, DLLs," \
578      "start menu entries, and other things your applications may need to install." \
579      "Where would you like your fake C drive to be placed?"
580     while [ -z "$CROOT" ]
581     do {
582       conf_string_answer "(default is $DCROOT) "
583       [ -z "$ANSWER" ] && ANSWER="$DCROOT"
584       if ! [ -d "$ANSWER" ]
585       then {
586         if mkdir -p "$ANSWER"
587         then CROOT="$ANSWER"
588         else
589           echo "Directory $ANSWER can't be created !"
590           conf_reset_question drivec_path
591         fi
592       }
593       else CROOT="$ANSWER"
594       fi
595     }
596     done
597     echo "Configuring Wine for a no-windows install in $CROOT..."
598
599     create_windows_directories
600     configure_wine_applications
601   }
602   fi
603
604   # create $LCONF using the default config file $WINEINI
605   if [ "$DOLOCALCONF" = 'yes' ] && [ "$CONVCONF" = 'no' ]
606   then {
607     sed "s|\"Path\" = \"/c\"\$|\"Path\" = \"${CROOT}\"|" $WINEINI > $TMPCONF
608     conf_reset_question default_config
609     conf_question low default_config \
610      "Created $LCONF using default Wine configuration." \
611      "You probably want to review the file, though."
612   }
613   fi
614
615   # now we really should install the registry
616   if [ "$DOREG" = 'auto' ]
617   then DOREG=yes
618   fi
619 }
620 fi
621 echo
622
623 #install the local config file $LCONF
624 if [ "$DOLOCALCONF" = 'yes' ]
625 then
626   if [ ! -w ~/.wine ]
627   then
628     mkdir ~/.wine
629   fi
630
631   if [ "$CONVCONF" = 'no' ]
632   then
633     cp $TMPCONF $LCONF > /dev/null
634   fi
635 else
636   DOREG=no
637 fi
638
639 #install the global config file $GCONF
640 if [ "$DOGLOBALCONF" = 'yes' ]
641 then
642   if [ ! -f $sysconfdir ]
643   then
644     mkdir -p $sysconfdir
645   fi
646
647   cp $TMPCONF $GCONF > /dev/null
648 fi
649
650 # check whether we need to install default registry
651 # (not to be done if windows registry exists)
652 if [ "$DOREG" = 'auto' ]
653 then {
654   CROOT=`sed -n '/^\[Drive C\]$/,/^\[.*\]$/ s/^\"Path\" = \"\(.*\)\"/\1/p' $LCONF`
655   echo "Checking for real Windows registry..."
656   if [ -f "$CROOT/windows/system.dat" ]
657   then DOREG=no
658   elif [ -f "$CROOT/windows/system32/config/system" ]
659   then DOREG=no
660   elif [ -f "$CROOT/WINNT/system32/config/system" ]
661   then DOREG=no
662   else DOREG=yes
663   fi
664   if [ "$DOREG" = 'yes' ]
665   then echo "Not found, default Wine registry will be installed."
666   else echo "Windows registry found, will not install default Wine registry."
667   fi
668   echo
669 }
670 fi
671
672 # install default registry entries
673 if [ "$DOREG" = 'yes' ]
674 then {
675   if [ "$BINDIST" = 'no' ]
676   then {
677     echo "Compiling regedit..."
678     (cd programs/regedit; make)
679     echo
680   }
681   fi
682   echo "Preparing to install default Wine registry entries..."
683
684   # edit config files so we don't have to run regedit under X
685   if [ "$CONVCONF" = 'yes' ]
686   then
687     mv $WINEINI $WINEINI.new
688     sed "s/GraphicsDriver=.*/GraphicsDriver=ttydrv/" $WINEINI.new > $WINEINI
689   else
690     mv $LCONF $LCONF.new
691     sed "s/\"GraphicsDriver\" = .*/\"GraphicsDriver\" = \"ttydrv\"/" $LCONF.new > $LCONF
692   fi
693
694   # create a temporary wineinstall.reg with fixed debugger path
695   $DEFCAT $DEFREG | sed "s|debugger/winedbg|${DEBUGGER}|" > $TMPREG
696
697   echo "Installing default Wine registry entries..."
698   echo
699   if ! $REGEDIT $TMPREG > /dev/null
700   then {
701     rm -f $TMPREG
702     echo "Registry install failed."
703     conf_reset_question regedit_error
704     conf_question high regedit_error
705     exit 1
706   }
707   else {
708     # if we are converting from a .winerc file, running regedit once
709     # will ONLY convert .winerc -> ~/.wine/config, it will not import the
710     # registry data.  so if we are converting we need to run regedit twice
711     if [ "$CONVCONF" = 'yes' ]
712     then
713       if ! $REGEDIT $TMPREG > /dev/null
714       then
715         rm -f $TMPREG
716         echo "Registry install failed."
717         conf_reset_question regedit_error
718         conf_question high regedit_error
719         exit 1
720       else
721         echo
722         echo "Registry entries successfully installed."
723       fi
724     else
725       echo
726       echo "Registry entries successfully installed."
727     fi
728   }
729   fi
730   rm -f $TMPREG
731   if [ "$SYSREG" = 'auto' ]
732   then SYSREG=yes
733   fi
734
735   # if we converted we need to change the graphics driver back and
736   # restore the original .winerc file
737   if [ "$CONVCONF" = 'yes' ]
738   then
739      mv $WINEINI.new $WINEINI
740   fi
741
742   sed "s/\"GraphicsDriver\" = .*/\"GraphicsDriver\" = \"x11drv\"/" $LCONF > $LCONF.new
743   mv $LCONF.new $LCONF
744 }
745 fi
746
747 # make root's registry global, if desired
748 if [ `whoami` = 'root' ] && [ "$DOREG" = 'yes' ] && [ "$SYSREG" = 'yes' ]
749 then {
750   [ -d ~/.wine ] || mkdir ~/.wine
751   if ! [ -f $sysconfdir/wine.userreg ]
752   then {
753     echo "Linking root's user registry hive to the global registry..."
754     [ -f ~/.wine/wine.userreg ] && cp ~/.wine/wine.userreg $sysconfdir/wine.userreg
755     ln -sf $sysconfdir/wine.userreg ~/.wine/wine.userreg
756   }
757   fi
758   if ! [ -f $sysconfdir/wine.systemreg ]
759   then {
760     echo "Linking root's system registry hive to the global registry..."
761     [ -f ~/.wine/system.reg ] && cp ~/.wine/system.reg $sysconfdir/wine.systemreg
762     ln -sf $sysconfdir/wine.systemreg ~/.wine/system.reg
763   }
764   fi
765 }
766 fi
767
768 # cleanup any temporary files that may remain
769 if [ -f $TMPCONF ]
770 then rm -f $TMPCONF
771 fi
772 if [ -f $TMPREG ]
773 then rm -f $TMPREG
774 fi
775
776
777 # it's a wrap
778 echo
779 echo "Installation complete for now. Good luck (this is still alpha software)."
780 echo "If you have problems with WINE, please read the documentation first,"
781 echo "as many kinds of potential problems are explained there."
782
783 exit 0